=== debian/changelog ===
libc++ (6.0-2) unstable; urgency=medium

  * Only run the testsuites on amd64, arm64 and i386

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 11 Mar 2018 17:37:11 +0100

libc++ (6.0-1) unstable; urgency=medium

  * New upstream release
  * Packaging moved to debian salsa
  * Build using clang 6 instead of 5
  * Add a watch file
  * Build with the glibc 2.27 (Closes: #891679)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 11 Mar 2018 11:47:45 +0100

libc++ (5.0.1-2) unstable; urgency=medium

  * Disable the execution of the testsuite on mips*

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 18 Jan 2018 22:33:13 +0100

libc++ (5.0.1-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version updated to 4.1.3

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 14 Jan 2018 18:44:22 +0100

libc++ (5.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version updated to 4.1.1
  * Update of the descriptions (were only mentionning C++11)
  * Fix priority-extra-is-replaced-by-priority-optional
  * Fix debian-rules-sets-dpkg-architecture-variable
  * glibc2.26.diff removed (fixed upstream)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 24 Nov 2017 18:53:01 +0100

libc++ (4.0.1-3) unstable; urgency=medium

  [ Matthias Klose ]
  * Ignore one more failing test on arm64

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 24 Nov 2017 17:29:58 +0100

libc++ (4.0.1-2) unstable; urgency=medium

  * Silent libcxx/atomics/atomics.align/align.pass.sh.cpp
    which fails on ppc64el
  * Silent thread.condition/thread.condition.condvar/wait_for.pass.cpp
    which fails on arm64

  [ Matthias Klose ]
  * Don't include xlocale.h. (glibc)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 10 Nov 2017 12:10:53 +0100

libc++ (4.0.1-1) unstable; urgency=medium

  * New upstream release
  * Update the llvm/clang dep to 4.0 (Closes: #873423)
  * Standards-Version to 4.0.0
  * Remove copyright-year-in-future (false positive)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 26 Aug 2017 20:37:36 +0200

libc++ (3.9.1-3) unstable; urgency=medium

  * Fix a typo in debian/control (Closes: #870440)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 02 Aug 2017 06:40:23 +0200
