=== debian/control ===
Source: libc++
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
 Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 9.0.0), cmake, clang-6.0, dh-exec, llvm-6.0-tools,
 locales-all
Standards-Version: 4.1.3
Section: libs
Homepage: http://libcxx.llvm.org/
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/libcxx.git
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/libcxx/

Package: libc++1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: clang
Description: LLVM C++ Standard library
 libc++ is another implementation of the C++ standard library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++ standards.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.

Package: libc++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc++1 (= ${binary:Version}), ${misc:Depends}, libc++-helpers
Provides: libstdc++-dev
Description: LLVM C++ Standard library (development files)
 libc++ is another implementation of the C++ standard library
 .
 Features and Goals
 .
   * Correctness as defined by the C++ standards.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.

Package: libc++-test
Section: libs
Architecture: any
Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
Description: LLVM C++ Standard library (test cases)
 libc++ is another implementation of the C++ standard library.
 .
 Features and Goals
 .
   * Correctness as defined by the standards.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.
 .
 This package contains the test cases of libc++ library.

Package: libc++abi1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LLVM low level support for a standard C++ library
 libc++abi is another implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++ standards.
   * Provide a portable sublayer to ease the porting of libc++
 .

Package: libc++abi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
Replaces: libc++-dev (<< 3.9.0-3)
Breaks: libc++-dev (<< 3.9.0-3)
Description: LLVM low level support for a standard C++ library (development files)
 libc++abi is another implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++ standards.
   * Provide a portable sublayer to ease the porting of libc++
 .

Package: libc++abi-test
Section: libs
Architecture: any
Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
Description: libc++abi test cases
 libc++abi is another implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++ standards.
   * Provide a portable sublayer to ease the porting of libc++
 .
 Test cases of libc++abi library.


Package: libc++-helpers
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: LLVM C++ Standard library - build helpers
 libc++ is another implementation of the C++ standard library
 .
 Features and Goals
 .
   * Correctness as defined by the C++ standards.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.
 .
 This package contains the build helpers (clang++-libc++, etc)
