## libc++ 6.0.1

=== debian/changelog ===
libc++ (6.0.1-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 01 Jul 2018 15:43:20 +0200

libc++ (6.0-3) unstable; urgency=medium

  * Remove some useless patches found by lintian
    patch-file-present-but-not-mentioned-in-series

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 17 Mar 2018 17:05:12 +0100
